
uniform sampler2DRect tex;

uniform float gamma;
uniform float a;
uniform float b;
uniform float c;
uniform float d;
uniform float e;
uniform float f;


#define Rec709GammaEncode(x)		mix(1.099 * pow(x, vec3(0.45)) - 0.099,  4.5 * x,  vec3(lessThan(x, vec3(0.018))))
#define ParametricGammaDecode(x)	mix(x * c + f, pow(a * x + b, vec3(gamma)) + e, vec3(greaterThanEqual(x, vec3(d))))

void main()
{
	vec4 color0 = texture2DRect(tex, gl_TexCoord[0].st);
	gl_FragColor = vec4(Rec709GammaEncode(ParametricGammaDecode(color0.rgb)), 1.0);
}

